// ChatServerObj.h : Declaration of the CChatServerObj

#ifndef __CHATSERVEROBJ_H_
#define __CHATSERVEROBJ_H_

#include "resource.h"       // main symbols



//-------------------------------------------------------------------
// Connection point object for IID_IReceiveMessage
//-------------------------------------------------------------------
template <class T> 
class CReceiveMessageCP : 
   public IConnectionPointImpl<T, &IID_IReceiveMessage>
{
public:
   void Fire_OnReply(wchar_t * pMessage)
   {
      T* pT = (T*)this;
      pT->Lock();  // Enter critical section

      IUnknown** pp = m_vec.begin();  // First element of the array
      IUnknown** ppEnd = m_vec.end(); // Last element of the array
      for ( ; pp < ppEnd ; pp++ ) {
         if (*pp!=NULL) {
            IReceiveMessage* pReply = reinterpret_cast<IReceiveMessage*>(*pp);
            // Send the message back to all sinks
            pReply->OnReply(pMessage);
         }
      }

      pT->Unlock();  // Exit critical section
   }
};



/////////////////////////////////////////////////////////////////////////////
// CChatServerObj
class ATL_NO_VTABLE CChatServerObj : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CChatServerObj, &CLSID_ChatServerObj>,
	public IConnectionPointContainerImpl<CChatServerObj>,
	public ISendMessage,
   public CReceiveMessageCP<CChatServerObj>
{
public:
	CChatServerObj()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CHATSERVEROBJ)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CChatServerObj)
	COM_INTERFACE_ENTRY(ISendMessage)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CChatServerObj)
    CONNECTION_POINT_ENTRY(IID_IReceiveMessage)
END_CONNECTION_POINT_MAP()


// ISendMessage
public:
	STDMETHOD(Talk)(/*[in, string]*/ wchar_t *pMessage);
};

#endif //__CHATSERVEROBJ_H_
