// ATLCyberGUI.h : Declaration of the CATLCyberGUI

#ifndef __ATLCYBERGUI_H_
#define __ATLCYBERGUI_H_

#include "resource.h"       // main symbols
#include <atlctl.h>




#include <comdef.h>

// Make sure the path is correct.
#import "c:\winnt4\system32\imgedit.ocx" \
   raw_native_types, no_namespace, \
   rename("_DImgEdit", "WangImageEdit"), \
   high_property_prefixes("Get","Set","PutRef_")


static char g_szFakeOcrText[10*MAX_PATH] = { 
	"COVERAGES AND LIMITS UNDER YOUR LIBERTYGUARD HOMEOWNERS POLICY\r\n"
    "YOUR DWELLING WITH REPLACEMENT COST\t\t$361,000\r\n"
    "OTHER STRUCTURES ON RESIDENCE PREMISES\t$36,100\r\n"
    "PERSONAL PROPERTY WITH REPLACEMENT COST\t$270,750\r\n"
    "LOSS OF USE OF YOUR RESIDENCE PREMISES\t$108,300\r\n"
    "PERSONAL LIABILITY (EACH OCCURRENCE)\t\t$300,000\r\n"
    "MEDICAL PAYMENTS TO OTHERS (EACH PERSON)\t$1,000\r\n"
    "\r\n"
    "||||||||||||||||||||||||||||||||||||||||||\r\n"
};




/////////////////////////////////////////////////////////////////////////////
// CATLCyberGUI
class ATL_NO_VTABLE CATLCyberGUI : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IATLCyberGUI, &IID_IATLCyberGUI, &LIBID_ATLCYBERCOMPOSITELib>,
	public CComCompositeControl<CATLCyberGUI>,
	public IPersistStreamInitImpl<CATLCyberGUI>,
	public IOleControlImpl<CATLCyberGUI>,
	public IOleObjectImpl<CATLCyberGUI>,
	public IOleInPlaceActiveObjectImpl<CATLCyberGUI>,
	public IViewObjectExImpl<CATLCyberGUI>,
	public IOleInPlaceObjectWindowlessImpl<CATLCyberGUI>,
	public IPersistStorageImpl<CATLCyberGUI>,
	public ISpecifyPropertyPagesImpl<CATLCyberGUI>,
	public IQuickActivateImpl<CATLCyberGUI>,
	public IDataObjectImpl<CATLCyberGUI>,
	public IProvideClassInfo2Impl<&CLSID_ATLCyberGUI, NULL, &LIBID_ATLCYBERCOMPOSITELib>,
	public CComCoClass<CATLCyberGUI, &CLSID_ATLCyberGUI>
{
public:
	CATLCyberGUI()
	{
		m_bWindowOnly = TRUE;
		CalcExtent(m_sizeExtent);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ATLCYBERGUI)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CATLCyberGUI)
	COM_INTERFACE_ENTRY(IATLCyberGUI)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CATLCyberGUI)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CATLCyberGUI)
	CHAIN_MSG_MAP(CComCompositeControl<CATLCyberGUI>)
   MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
   COMMAND_HANDLER(IDC_BUTTON_VIEW_IMAGE, BN_CLICKED, OnViewImage)
   COMMAND_HANDLER(IDC_BUTTON_FIT_BEST, BN_CLICKED, OnFitBest)
   COMMAND_HANDLER(IDC_BUTTON_FIT_WIDTH, BN_CLICKED, OnFitWidth)
   COMMAND_HANDLER(IDC_BUTTON_ZOOM, BN_CLICKED, OnZoom)
   COMMAND_HANDLER(IDC_BUTTON_ROTATE, BN_CLICKED, OnRotate)
   COMMAND_HANDLER(IDC_BUTTON_OCR, BN_CLICKED, OnOcr)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

BEGIN_SINK_MAP(CATLCyberGUI)
	//Make sure the Event Handlers have __stdcall calling convention
END_SINK_MAP()

	STDMETHOD(OnAmbientPropertyChange)(DISPID dispid)
	{
		if (dispid == DISPID_AMBIENT_BACKCOLOR)
		{
			SetBackgroundColorFromAmbient();
			FireViewChange();
		}
		return IOleControlImpl<CATLCyberGUI>::OnAmbientPropertyChange(dispid);
	}


   LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
   {
      SetDlgItemText(IDC_EDIT_SERVER_NAME, "dog") ;
      SetDlgItemText(IDC_EDIT_IMAGE_LOCATION, "c:\\temp\\test.tif") ;
      HWND h = GetDlgItem(IDC_IMAGE_EDIT);
      try {
         if (h!=NULL) {
            CComPtr<IUnknown> pUnk;
            AtlAxGetControl(h, &pUnk);
            if (pUnk!=NULL) {
               HRESULT hr = pUnk->QueryInterface(IID_IDispatch,
                                  reinterpret_cast<void**>(&m_pWang));
               if (FAILED(hr)) _com_issue_error(hr);
            }
         }
      } catch (_com_error & er) {
         if (er.Description().length()>0) {
            MessageBox(er.Description(), "Description");
         } else {
            MessageBox(er.ErrorMessage(), "Error");
         }
      }

      return 0;
   }


   LRESULT OnViewImage(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
   {
      try {
         TCHAR szImageFile[MAX_PATH];
         GetDlgItemText(IDC_EDIT_IMAGE_LOCATION, szImageFile, MAX_PATH);
         CComBSTR tif(szImageFile);
         // Set the image to be displayed.
         m_pWang->SetImage(tif);
         // Display the image inside the Wang image edit control.
         m_pWang->Display();
      } catch(_com_error & er) {
         if (er.Description().length()>0) {
            MessageBox(er.Description(), "Description");
         } else {
            MessageBox(er.ErrorMessage(), "Error");
         }   }
      return 0;
   }

   LRESULT OnFitBest(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
   {
      try {
         VARIANT v; v.vt = VT_BOOL; v.boolVal = TRUE;
         m_pWang->FitTo(0, v);
      } catch(_com_error & er) {
         if (er.Description().length()>0) {
            MessageBox(er.Description(), "Description");
         } else {
            MessageBox(er.ErrorMessage(), "Error");
         }   }
      return 0;
   }

   LRESULT OnFitWidth(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
   {
      try {
         VARIANT v; v.vt = VT_BOOL; v.boolVal = TRUE;
         m_pWang->FitTo(1, v);
      } catch(_com_error & er) {
         if (er.Description().length()>0) {
            MessageBox(er.Description(), "Description");
         } else {
            MessageBox(er.ErrorMessage(), "Error");
         }
      }
      return 0;
   }

   LRESULT OnZoom(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
   {
      try {
         m_pWang->ZoomToSelection() ;
      } catch(_com_error & er) {
         if (er.Description().length()>0) {
            MessageBox(er.Description(), "Description");
         } else {
            MessageBox(er.ErrorMessage(), "Error");
         }   }
      return 0;
   }

   LRESULT OnRotate(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
   {
      try {
         m_pWang->RotateRight() ;
      } catch(_com_error & er) {
         if (er.Description().length()>0) {
            MessageBox(er.Description(), "Description");
         } else {
            MessageBox(er.ErrorMessage(), "Error");
         }   }
      return 0;
   }

   LRESULT OnOcr(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
   {
      SetDlgItemText(IDC_EDIT_TEXT, g_szFakeOcrText) ;
      return 0;
   }


// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// IATLCyberGUI
public:

	enum { IDD = IDD_ATLCYBERGUI };

private:
   CComPtr<WangImageEdit> m_pWang;  
};

#endif //__ATLCYBERGUI_H_
